#sf_sink
#demo(package="igraph") 
#install.packages("Rcpp")
#install.packages("dils") 
library(dils)
library(igraph)
library(MASS)
setwd("F:/19-mst-knn/contoh_model_graph")
#aging.ba.game, sample_asym_pref, canonical_permutation, callaway.traits.game
#sample_last_cit, each_edge [rewiring??], make_full_citation_graph, gnm, gnp, permute(graph, permutation)
edge <- function(x, nodes) { y=ecount(x)/nodes/(nodes-1)*100; return (y) }
edge(g, nodes);

N=1; Ntimes=3; nodes=500; dim=1; nei=25; p=0.6; Edensity=2; kcount=0;  epsilon=0.08
#size=10
edges = ceiling(nodes*(nodes-1)*2*Edensity/100)
while (N <= Ntimes) #Generate next SCALE-FREE graph matrix
{ k=0; kcount=0;
  g1 <- sample_smallworld(dim, nodes, nei, p) 
  g2 <- sample_smallworld(dim, nodes, nei, p)
# get feedback loops:MUST use [1]as.directed, [2]permute. DO NOT use [2], [1]  
  gd1 = as.directed(g1, mode = "arbitrary")
  gd2 = as.directed(g2, mode = "arbitrary")
  gp1= permute(gd1, sample(vcount(gd1)))  # dir = is_directed(g); print(dir)
  gp2= permute(gd2, sample(vcount(gd2))) 
  g= union(gp1,gp2)
     if (edge(g, nodes) < Edensity-epsilon) { next
                                 }
          else { e=signif(edge(g, nodes),3) }
  tmp=dfs(g,root=1, neimode="total", unreachable=F, order=T,order.out=F, father=F, dist=F)
  x=as.character(tmp$order) #store tmp$order NA as character
      for (k in 1:nodes) {
        if (is.na(x[k])==T) {
          kcount=kcount+1;  break } #end of if loop
                             }    # end of k in 1:nodes loop
#output the small-world graph
          if (kcount==0) {  
            cat("cat Edensity=", e,"%", "\n")
            t<-g[]
            write.matrix(t,paste0("SW",N,"_",nodes,"_",Edensity,".txt"))
               N=N+1   #the graph is usable
                        }  # end of (kcount==nodes) loop
  }       # end of while (N <= Ntimes)

any_multiple(g)
plot(g)
#write_graph(g, "./g.txt", "edgelist")# relabel node 1 to 0 !!!
#write_graph(g, "./gdot.txt", "dot")
#write_graph(g, "./gcol.txt", "ncol")# relabel node 1 to 0 !!!
#write_graph(g, "./gml.txt", "gml")
#write_graph(g, "./glgl.txt", "lgl")
write_graph(g, "./write_igraph format/gpajek.txt", "pajek")
#write_graph(g, "./graphml.txt", "graphml")
#write_graph(g, "./gleda.txt", "leda")
pajek= read.csv("./write_igraph format/gpajek.txt",header=TRUE, sep=" ")
dim_pajek=dim(pajek)
pajek_new=pajek[2:dim_pajek,]; pajek_new
names(pajek_new) <-c("in", "out"); pajek_new
g1=paste0(pajek_new[,2],",",pajek_new[,1], collapse=","); g1
#out=paste0(pajek$V2,",",pajek$V1, collapse=",")
g2=add_edges(g,c(g1))
###  Error in as.igraph.vs(graph, edges) : Invalid vertex name(s)
#gs=induced_subgraph(g,1:7)
#ge=subgraph.edges(g, 1:5, 1:5)
#sprintf("Edensity=%.3f",e) # why it does not work??????
#gx <- make_empty_graph(n = 5) %>%
#  add_edges(c(1,2, 2,3, 3,4, 4,5, 2,1, 3,2, 1,5))%>%
#  set_edge_attr("color", value = "red")%>%
#  add_edges(c(5,1), color = "green")
#E(gx)[[]]
#plot(gx)
#motifs(graph, size = 3, cut.prob = rep(0, size))
#test <- ends(g, E(g))
#plot(g,vertex.color="grey", edge.color="blue")
#tmp$order
#x=array(c(1:16),dim=c(4,2,2)); x
#x[,,1]; 
#x[,,2]
#adj_array[1]
#adj_array[2]
#edge=as.matrix(g, matrix.type = c("adjacency"),sparse = T)
#edge
# print(tmp$order);
# adj=as_adj(g,type="both")# convert UNdirected graph to adjacency matrix
# adj_array=array(adj,dim=c(nodes,nodes,N))
#print(N); 
#  print(adj); print(adj_array)
#  adj=matrix(0,nodes,nodes)
#  adj_array=array(matrix(0, nodes, nodes),dim=c(nodes,nodes,Ntimes))  
# edgelist=as.matrix(g, "edgelist",attrname=NULL)
#edgelist=as.data.frame(edgelist)
#adj=AdjacencyFromEdgelist(edgelist,check.full = TRUE)#need THREE columns
#print(adj)

