setwd("F:/19-mst-knn/coba")
library(igraph)
library(dils)
library(MASS)
#parameters and generated
setwd("F:/19-mst-knn/coba/crg_6")
N=1;nodes=400;pam_den=6 #pam_den percentages
agebins = nodes/100 #"at least two age bins are need for lastcit game" divide and must be left more than 2
g <-graph.empty(nodes, directed=TRUE);edge_density(g)
g1 <- sample_last_cit(nodes,edges = 1,agebins,pref = (1:(agebins+1))^3,directed = TRUE)
g=permute(g1,sample(vcount(g1)));edge_density(g)
#============================
#Calculate edge density
Edensity=edge_density(g, loops=TRUE);Edensity;Edensity=round(Edensity*100,2);Edensity
#============================
#stop when around pam_den
while (Edensity < pam_den) {
  g2 <-graph.empty(nodes, directed=TRUE)
  g2 <- sample_last_cit(nodes,edges = 1,agebins,pref = (1:(agebins+1))^3,directed = TRUE)
  gp <-permute(g2,sample(vcount(g2)))
  g <-union(gp,g) #give a new edges plus for g
  Edensity=edge_density(g, loops=TRUE);Edensity=round(Edensity*100,2)
  print(Edensity)
}
Edensity
#============================
#print out to text file
t<-g[]
write.matrix(t,paste0("crg",N,"_",nodes,"_",Edensity,"%.txt"))
#============================
#Check whether any multiply node or not
any_multiple(g)
#============================
#Plot graph
plot(g,vertex.color="grey", edge.color="blue")
#============================
is.igraph(g)
is.connected(g)
is.simple(g)
is.named(g)
is_simple(g)
is.directed(g)

