#demo(package="igraph") 
install.packages("Rcpp")
#install.packages("dils") 
library(dils)
library(igraph)
library(MASS)
setwd("F:/19-mst-knn/contoh_model_graph")
#generate random graph ER model#prob >0.4, else disjoint graph
edge <- function(x, nodes) { y=ecount(x)/nodes/(nodes-1)*100; return (y) }
edge(g, nodes);
#prob=0.005; Edensity=0.5%
#prob=0.01; Edensity=1 %
#aging.ba.game, sample_asym_pref, canonical_permutation, callaway.traits.game
#sample_last_cit, each_edge [rewiring??], make_full_citation_graph, gnm, gnp, permute(graph, permutation)
#sample_smallworld?perm
N=1; Ntimes=3; nodes=300; prob=0.0188; Edensity=2; kcount=0; epsilon=0.02
#N=1; Ntimes=2; nodes=10; prob=0.5; Edensity=5; kcount=0; epsilon=0.05
while (N <= Ntimes) #Generate next random graph matrix
{ k=0; kcount=0;
  g1 <- erdos.renyi.game(nodes, prob, directed=TRUE)
  g2 <- erdos.renyi.game(nodes, prob, directed=TRUE)
  gp1= permute(g1, sample(vcount(g1)))  # dir = is_directed(g); print(dir)
  gp2= permute(g2, sample(vcount(g2)))
  g=union(gp1,gp2)
  g = permute(g1, sample(vcount(g1))) 
  if (edge(g, nodes) < Edensity-epsilon) { next
#    print("delete graph g"); print("line 22");print (N); 
                                 }
        else { e=signif(edge(g, nodes),3) }
  tmp=dfs(g,root=1, neimode="total", unreachable=F, order=T,order.out=F, father=F, dist=F)
  x=as.character(tmp$order) #store tmp$order NA as character
      for (k in 1:nodes) {
        if (is.na(x[k])==T) {
          kcount=kcount+1;  break } #end of if loop
                             }    # end of k in 1:nodes loop
#output the random graph
          if (kcount==0) {  
            cat("cat Edensity=", e,"%", "\n")
            t<-g[]
            write.matrix(t,paste0("rg",N,"_",nodes,"_",Edensity,".txt"))
# write_graph(g, paste0("rg",N,"_",nodes,"_",Edensity,".txt"), format = c("edgelist"))
               N=N+1   #the graph is usable
                        }  # end of (kcount==nodes) loop
  }       # end of while (N <= Ntimes)
any_multiple(g)
sprintf("Edensity=%.3f",e) # why it does not work??????
print(e);
#plot(g)
#motifs(graph, size = 3, cut.prob = rep(0, size))
#test <- ends(g, E(g))
#plot(g,vertex.color="grey", edge.color="blue")
#tmp$order
#x=array(c(1:16),dim=c(4,2,2)); x
#x[,,1]; 
#x[,,2]
#adj_array[1]
#adj_array[2]
#edge=as.matrix(g, matrix.type = c("adjacency"),sparse = T)
#edge
# print(tmp$order);
# adj=as_adj(g,type="both")# convert UNdirected graph to adjacency matrix
# adj_array=array(adj,dim=c(nodes,nodes,N))
#print(N); 
#  print(adj); print(adj_array)
#  adj=matrix(0,nodes,nodes)
#  adj_array=array(matrix(0, nodes, nodes),dim=c(nodes,nodes,Ntimes))  
# edgelist=as.matrix(g, "edgelist",attrname=NULL)
#edgelist=as.data.frame(edgelist)
#adj=AdjacencyFromEdgelist(edgelist,check.full = TRUE)#need THREE columns
#print(adj)
