install.packages("mstknnclust")
setwd("F:/19-mst-knn")
getwd()
#loads package
library("mstknnclust")
#loads dataset
data(dslanguages)
head(dslanguages)
#Performs MST-kNN clustering using dslanguages distance matrix
results <- mst.knn(dslanguages,10);results
dim(dslanguages)
results
library("igraph")
igraph::V(results$network)$label.cex <- seq(0.6,0.6,length.out=2)
plot(results$network, vertex.size=8, 
     vertex.color=igraph::clusters(results$network)$membership, 
     layout=igraph::layout.fruchterman.reingold(results$network, niter=10000),
     main=paste("MST-kNN \n Clustering solution \n Number of clusters=",results$cnumber,sep="" ))

?mst.knn;head(jsd_data)
jsd_data <- read.csv(file = 'cluster_nw54_2&6.csv')
dim(jsd_data)
hasil<-mst.knn(jsd_data,suggested.k = 0);hasil
igraph::V(hasil$network)$label.cex <- seq(0.6,0.6,length.out=2)
plot(hasil$network, vertex.size=11, 
     vertex.color=igraph::clusters(hasil$network)$membership, 
     layout=igraph::layout.fruchterman.reingold(hasil$network, niter=100),
     main=paste("Network Clustering \n 6 network types\n Number of clusters=",hasil$cnumber,sep="" ))

