setwd("F:/19-mst-knn/coba")
library(igraph)
library(dils)
library(MASS)
#parameters and generated
setwd("F:/19-mst-knn/coba/arg_6")
N=1;Ntimes=3;nodes=400;pam_den=6;epsilon=0.03 #pam_den percentages
batas_bawah=pam_den-epsilon;batas_atas=pam_den+epsilon
batas_atas;batas_bawah
g <-graph.empty(nodes, directed=TRUE);edge_density(g)
g1 <- sample_pa_age(nodes, pa.exp=1, aging.exp=-1, aging.bin=1000)
g=permute(g1,sample(vcount(g1)));edge_density(g)
#============================
#Calculate edge density
Edensity=edge_density(g, loops=FALSE);Edensity;Edensity=round(Edensity*100,2);Edensity
#============================
#stop when around pam_den
while (N <= Ntimes) {
  if (Edensity > 5.8){
    g2 <-graph.empty(nodes, directed=TRUE)
    g2 <- sample_pa_age(60, pa.exp=1, aging.exp=-1, aging.bin=1000)
    gp <-permute(g2,sample(vcount(g2)))
    g <-union(gp,g)
  }
  else{
    g2 <-graph.empty(nodes, directed=TRUE)
    g2 <- sample_pa_age(nodes, pa.exp=1, aging.exp=-1, aging.bin=1000)
    gp <-permute(g2,sample(vcount(g2)))
    g <-union(gp,g)
  }
  Edensity=edge_density(g, loops=FALSE);Edensity=round(Edensity*100,2)
  print(Edensity)
  if (Edensity < batas_bawah){
    cat("checkpoint:",Edensity)
    next
  }  
  else if (Edensity > batas_atas){
    g <-graph.empty(nodes, directed=TRUE);edge_density(g)
    g1 <- sample_pa_age(nodes, pa.exp=1, aging.exp=-1, aging.bin=1000)
    g=permute(g1,sample(vcount(g1)));edge_density(g)
    #Calculate edge density
    Edensity=edge_density(g, loops=FALSE);Edensity;Edensity=round(Edensity*100,2);
    Edensity
    print(N)
    next
  }
  else {
    #============================
    #print out to text file
    t<-g[]
    write.matrix(t,paste0("arg",N,"_",nodes,"_",Edensity,"%.txt"))
    #============================
    #Plot graph
    plot(g,vertex.color="grey", edge.color="blue")
    N=N+1
  }
  }
#============================
is.igraph(g)
is.connected(g)
is.simple(g)
is.named(g)
is_simple(g)
is.directed(g)
#============================
#Check whether any multiply node or not
any_multiple(g)

